-- 1013
-- Analog Value properties and variables added
-- SRA added to initialize Analog Variabes - requires firmware v1.2.0 or higher
require("fnip_common");


-------------------------Settings-----------------------------------------


g_Module_Type="FNIP-12xIO"
g_Firmware_Compatiblity="1.0.5"
-- Common compatibility: 1.2.10

g_ReadConfigCommands = {
    "GETMODE",
    "GETMTYPE",
    "GETMAC",
    "GETVER",
    "SRE",
	"SRA",
    "SRI",
	"GETTHRESH"
}

g_input_id_shift = 30

-------------------------Variables----------------------------------------

-- Global Variables


g_Values={["1"]=0,["2"]=0,["3"]=0,["4"]=0,["5"]=0,["6"]=0,["7"]=0,["8"]=0,["9"]=0,["10"]=0,["11"]=0,["12"]=0,["13"]=0}

g_ChannelBindings={11,12,13,14,15,16,17,18,19,20,21,22,23}
C4:AddVariable("Analog Input 01 Value",0,"NUMBER")
C4:AddVariable("Analog Input 02 Value",0,"NUMBER")
C4:AddVariable("Analog Input 03 Value",0,"NUMBER")
C4:AddVariable("Analog Input 04 Value",0,"NUMBER")
C4:AddVariable("Analog Input 05 Value",0,"NUMBER")
C4:AddVariable("Analog Input 06 Value",0,"NUMBER")
C4:AddVariable("Analog Input 07 Value",0,"NUMBER")
C4:AddVariable("Analog Input 08 Value",0,"NUMBER")
C4:AddVariable("Analog Input 09 Value",0,"NUMBER")
C4:AddVariable("Analog Input 10 Value",0,"NUMBER")
C4:AddVariable("Analog Input 11 Value",0,"NUMBER")
C4:AddVariable("Analog Input 12 Value",0,"NUMBER")

function OnPropertyChanged(strProperty)
    PropertyChangedCommon(strProperty)
    dbg("4831: OnPropertyChanged")
    --if the property "Channel1 Input Mode" changed
    strVal=string.match(strProperty,"Channel(%d+) Input Mode")
    
    if(strVal~=nil) then
	   local chNum=tonumber(strVal)
	   --dbg("4833: chnum: " .. strVal)
	   --set the channel1 input mode of the physical module to the desired state
	   if (Properties[strProperty] == "Independent") then
		  queueMessage("FN,MODE,".. chNum ..",0\r")
	   elseif (Properties[strProperty] == "Toggle") then
		  queueMessage("FN,MODE,".. chNum ..",1\r")
	   elseif (Properties[strProperty] == "Follow") then
		  queueMessage("FN,MODE,".. chNum ..",2\r")
	   --elseif(Properties[strProperty] == "Monostable") then
		  --queueMessage("FN,MODE,".. chNum ..",3\r")
	   elseif(Properties[strProperty] == "Maintained Switch") then
		  queueMessage("FN,MODE,".. chNum ..",4\r")
	   elseif(Properties[strProperty] == "Scene on push") then
		  queueMessage("FN,MODE,".. chNum ..",5\r")
	   elseif(Properties[strProperty] == "Scene on release") then
		  queueMessage("FN,MODE,".. chNum ..",6\r")
	   end
	   return
    end
	
	strVal=string.match(strProperty,"Channel(%d+) Threshold")
    if(strVal~=nil) then
	   local chNum=tonumber(strVal)
	   sendCommand("THRESH,".. chNum .. "," .. Properties[strProperty])
    end
	
end


--------------------------Command Handling-----------------------------------

-- UIRequest is used to handle commands from a SendToDevice()
function UIRequest(strCommand, tParams)
	dbg("UIRequest called with : " .. strCommand)
	
	if(strCommand == "GET_RANDOM_NUMBER") then
		-- The return value must be valid xml
		return "<random_number value='" .. Properties["Random Number"] .. "' />"
	end
end


function ReceivedFromNetwork(idBinding, nPort, strData)
    if(idBinding==g_ServerBinding) then
	   local channel
	   local mode
	   local val
	   local strDataTemp
	   dbg("received data:"..strData.."\n")
	   ClearConnectionWatchdog()

	   g_ReceiveBuffer=g_ReceiveBuffer..strData
	   repeat
		  strDataTemp=(string.match(g_ReceiveBuffer,"(%b>\13)", 1))
		  g_ReceiveBuffer=string.gsub(g_ReceiveBuffer,"(%b>\13)", "",1)
		  if(strDataTemp~=nil) then
			 command=string.match(strDataTemp,"FN,(%a*)")
			 command=string.upper(command)
			 dbg("command:"..command)
			 if(command=="OUT") then
				param1,channel=string.match(strDataTemp,"FN,"..command..",(%a+),(%d+)")
				channel=tonumber(channel)
				if (param1 == "ON") then
				    if(channel~=nil) then
					   g_Values[channel]=100
					   SendToProxy (10+channel,"LIGHT_LEVEL_CHANGED",{LEVEL="100"})
					   SendToProxy (10+channel,"CLOSED",{},"NOTIFY")
				    end
				elseif(param1=="OFF") then
				    if(channel~=nil) then
					   g_Values[channel]=0
					   SendToProxy (10+channel,"LIGHT_LEVEL_CHANGED",{LEVEL="0"})
					   SendToProxy (10+channel,"OPENED",{},"NOTIFY")
				    end
				end
			 elseif (command=="IN") then
				param1=string.match(strDataTemp,"FN,IN,(%a*)")
				param1=string.upper(param1)
				if (param1 =="VAL") then
					dbg("param1:".. param1)
					channel,val = string.match(strDataTemp,"FN,IN,VAL,(%d+),(%d+)")
					channel=tonumber(channel)
					C4:SetVariable("Analog Input " .. string.format("%02d", channel) .. " Value",val)
					if (val == "1000") then val="> 999" end
					C4:UpdateProperty ("Analog Input ".. string.format("%02d", channel) .." Value" , val)
				else
					-- done in fnip_common
					--[[channel,param1=string.match(strDataTemp,"FN,IN,(%d+),(%a+)")
					if( (param1 ~= "ON") and (param1 ~= "OFF") ) then
						 param1,channel=string.match(strDataTemp,"FN,IN,(%a+),(%d+)")
					end
					channel=tonumber(channel)
					if(channel~=nil) then
						if(param1=="ON") then
							C4:UpdateProperty ("Analog Input ".. string.format("%02d", channel) .." Value" , "ON")
						elseif (param1=="OFF") then
							C4:UpdateProperty ("Analog Input ".. string.format("%02d", channel) .." Value" , "OFF")
						end
					end --]]
					CommonCommandHandler(strDataTemp) -- let the fn_ipcommon parse didgit input changes 
				end
			 elseif(command=="MODE") then
				channel,param1=string.match(strDataTemp,"FN,"..command..",(%d+),(%d+)")
				channel=tonumber(channel)
				param1=tonumber(param1)
				if(channel~=nil) then
				    if(param1==0) then
					   propValue="Independent"
				    elseif(param1==1) then
					   propValue="Toggle"
				    elseif(param1==2) then
					   propValue="Follow"
				    --elseif(param1==3) then
					   --propValue="Monostable"
				    elseif(param1==4) then
					   propValue="Maintained Switch"
				    elseif(param1==5) then
					   propValue="Scene on push"
				    elseif(param1==6) then
					   propValue="Scene on release"
				    end
				    C4:UpdateProperty("Channel".. channel .. " Input Mode",propValue)
				end
			  elseif(command=="THRESH") then
				channel,param1=string.match(strDataTemp,"FN,"..command..",(%d+),(%d+)")
				channel=tonumber(channel)
				local threshold=tonumber(param1)
				if(channel~=nil) then
				    C4:UpdateProperty("Channel".. channel .. " Threshold" ,    threshold)
				end
			 else
				CommonCommandHandler(strDataTemp) -- parsings that are not specific to this driver are done in the fn_ipcommon
			 end
		  end
	   until strDataTemp==nil
	   g_ReceiveBuffer=string.gsub(g_ReceiveBuffer,"(>.*>)", ">",1)
    end
end

function CommandInterpreter(idBinding, strCommand, tParams)
	if (strCommand ~= nil) then
		if(tParams == nil)    -- initial table variable if nil
			then tParams = {}
		end
		-- dbg("Received from Proxy: " .. strCommand .. " on binding " .. idBinding .. "; Call Function " .. strCommand .. "()")
		
		if (idBinding  >= g_ChannelBindings[1] and idBinding<=g_ChannelBindings[13]) then
			local channel=idBinding-10
			tParams.CHANNEL=channel
			-- notifies
			if (strCommand == "GET_LIGHT_LEVEL") then
				GET_LIGHT_LEVEL(idBinding, tParams)
			elseif (strCommand == "GET_CONNECTED_STATE") then
				SendToAllProxy("ONLINE_CHANGED", "True")
			-- commands
			elseif (strCommand == "ON") then
				ON(tParams)
			elseif (strCommand == "CLOSE") then
				ON(tParams)
			elseif (strCommand == "OFF") then
				OFF(tParams)
			elseif (strCommand == "OPEN") then
				OFF(tParams)
			elseif (strCommand == "TRIGGER") then
				TRIGGER(tParams)
			elseif (strCommand == "TOGGLE") then
				TOGGLE(tParams)
			elseif (strCommand == "TOGGLE_PRESET") then
				TOGGLE(tParams)
			elseif (strCommand == "SET_LEVEL") then
				SET_LEVEL(tParams)
			elseif (strCommand == "RAMP_TO_LEVEL") then
				SET_LEVEL(tParams)
			elseif (strCommand == "CLICK_TOGGLE_BUTTON") then
				TOGGLE(tParams)
			else
				C4:SendToProxy(g_ServerBinding, strCommand, tParams)
			end	
		elseif (idBinding == FNGWBinding) then
			if (strCommand == "GET_PROPERTIES") then
			else
				local tParams = {DEVICE_ID = C4:GetDeviceID()}
				SendToAllProxy(strCommand, tParams)
			end
		end
	end
end

function TOGGLE_PRESET(tParams)
	if(tParams~=nil) then
		queueMessage("FN,TOG," .. tParams.CHANNEL.."\r")
	end
end

function TOGGLE(tParams)
	if(tParams~=nil) then
		queueMessage("FN,TOG," .. tParams.CHANNEL.."\r")
	end
end

function ON(tParams)
	if(tParams~=nil) then
		queueMessage("FN,ON," .. tParams.CHANNEL.."\r")
	end
end

function TRIGGER(tParams)
	if(tParams~=nil) then
		tParams.TIME=math.floor((tParams.TIME+499)/1000)
		queueMessage("FN,MON," .. tParams.CHANNEL..","..tParams.TIME.."\r")
	end
end

function SET_LEVEL(tParams)
	--set the parameters of the FutureNow command - address,output,command=211(set level),param=level
	if(tParams~=nil) then
		if(tonumber(tParams.LEVEL)>0) then
			queueMessage("FN,ON," .. tParams.CHANNEL.."\r")	
		else
			queueMessage("FN,OFF," .. tParams.CHANNEL.."\r")
		end
	end
end

function OFF(tParams)
	if(tParams~=nil) then
		queueMessage("FN,OFF," .. tParams.CHANNEL.."\r")
	end
end

function GET_LIGHT_LEVEL(idBinding,tParams)
	if(g_Values[idBinding-10]==0) then
		SendToProxy(idBinding,"OPENED",{})
	else
		SendToProxy(idBinding,"CLOSED",{})
	end
	SendToProxy(idBinding,"LIGHT_LEVEL_CHANGED",{LEVEL=tostring(g_Values[idBinding-10])})
end

